/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of LibIDN.xs. Do not edit this file, edit LibIDN.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "LibIDN.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <idna.h>
#include <punycode.h>
#include <stringprep.h>

#ifdef HAVE_TLD
#include <tld.h>
#endif

#define MAX_DNSLEN 4096

static char * default_charset= "ISO-8859-1";

char *
idn_prep(char * string, char * charset, char * profile)
{
	char * output = NULL;
	char * res_str = NULL;
	char * utf8 = NULL;
	int res;
	
    utf8 = stringprep_convert(string, "UTF-8", charset);
	if (!utf8)
		return NULL;

	res = stringprep_profile(utf8, &output, profile, 0);
	free(utf8);

	if( (res != STRINGPREP_OK) || !output)
		return NULL;

	res_str = stringprep_convert(output, charset, "UTF-8");
	free(output);

	return res_str;
}

static double
constant(char *name, int len, int arg)
{
	errno = 0;
	if (0 + 5 >= len )
	{
		errno = EINVAL;
		return 0;
	}
	switch (name[0 + 5]) 
	{
		case 'A':
		if (strEQ(name + 0, "IDNA_ALLOW_UNASSIGNED"))
		{
			return IDNA_ALLOW_UNASSIGNED;
		}
    case 'U':
		if (strEQ(name + 0, "IDNA_USE_STD3_ASCII_RULES"))
		{
			return IDNA_USE_STD3_ASCII_RULES;
		}
	}
	errno = EINVAL;
	return 0;
}

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 81 "LibIDN.c"

XS(XS_Net__LibIDN_constant); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_constant)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::constant", "sv, arg");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 73 "LibIDN.xs"
	STRLEN		len;
#line 97 "LibIDN.c"
	SV *	sv = ST(0);
	char *	s = SvPV(sv, len);
	int	arg = (int)SvIV(ST(1));
	double	RETVAL;
	dXSTARG;
#line 79 "LibIDN.xs"
	RETVAL = constant(s,len,arg);
#line 105 "LibIDN.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__LibIDN_idn_to_ascii); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_idn_to_ascii)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::idn_to_ascii", "string, charset=default_charset, flags=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	string = (char *)SvPV_nolen(ST(0));
	char *	charset;
	int	flags;
#line 91 "LibIDN.xs"
		char *	utf8_str = NULL;
		char *	tmp_str = NULL;
		int		res;
#line 131 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1));
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2));
	}
#line 95 "LibIDN.xs"
		utf8_str = stringprep_convert(string, "UTF-8", charset);
		if (utf8_str)
		{
			res = idna_to_ascii_8z(utf8_str, &tmp_str, flags);
			free(utf8_str);
		}
		else
		{
			XSRETURN_UNDEF;
		}
		if (res!=IDNA_SUCCESS)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = tmp_str;
#line 162 "LibIDN.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 113 "LibIDN.xs"
		if (tmp_str)
			free(tmp_str);
#line 167 "LibIDN.c"
    }
    XSRETURN(1);
}


XS(XS_Net__LibIDN_idn_to_unicode); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_idn_to_unicode)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::idn_to_unicode", "string, charset=default_charset, flags=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	string = (char *)SvPV_nolen(ST(0));
	char *	charset;
	int	flags;
#line 124 "LibIDN.xs"
		char *	tmp_str = NULL;
		char *	res_str = NULL;
		int		res;
#line 192 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1));
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2));
	}
#line 128 "LibIDN.xs"
		res = idna_to_unicode_8z8z(string, &tmp_str, flags);
		if(res != IDNA_SUCCESS)
		{
			XSRETURN_UNDEF;
		}
		if (tmp_str)
		{
			res_str = stringprep_convert(tmp_str, charset, "UTF-8");
			free(tmp_str);
		}
		else
		{
			XSRETURN_UNDEF;
		}
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 227 "LibIDN.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 150 "LibIDN.xs"
		free(res_str);
#line 231 "LibIDN.c"
    }
    XSRETURN(1);
}


XS(XS_Net__LibIDN_idn_punycode_encode); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_idn_punycode_encode)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::idn_punycode_encode", "string, charset=default_charset");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	string = (char *)SvPV_nolen(ST(0));
	char *	charset;
#line 159 "LibIDN.xs"
		char *		utf8_str = NULL;
		uint32_t *	q = NULL;
		size_t		len,len2;
		char *		tmp_str = NULL;
		char *		res_str = NULL;
		int			res;
#line 258 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1));
	}
#line 166 "LibIDN.xs"
		utf8_str = stringprep_convert(string, "UTF-8", charset);
		if (utf8_str)
		{
			q = stringprep_utf8_to_ucs4(utf8_str, -1, &len);
			free(utf8_str);
		}
		else
		{
			XSRETURN_UNDEF;
		}

		if (!q)
		{
			XSRETURN_UNDEF;
		}

		tmp_str = malloc(MAX_DNSLEN*sizeof(char));
		len2 = MAX_DNSLEN-1;
		res = punycode_encode(len, q, NULL, &len2, tmp_str);
		free(q);

		if (res != PUNYCODE_SUCCESS)
		{
			XSRETURN_UNDEF;
		}

		tmp_str[len2] = '\0';	

		res_str = stringprep_convert(tmp_str, charset, "UTF-8");
		free(tmp_str);
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 303 "LibIDN.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 204 "LibIDN.xs"
		free(res_str);
#line 307 "LibIDN.c"
    }
    XSRETURN(1);
}


XS(XS_Net__LibIDN_idn_punycode_decode); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_idn_punycode_decode)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::idn_punycode_decode", "string, charset=default_charset");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	string = (char *)SvPV_nolen(ST(0));
	char *	charset;
#line 213 "LibIDN.xs"
		char *		utf8_str = NULL;
		uint32_t *	q = NULL;
		size_t		len;
		char *		res_str = NULL;
		int			res;
#line 333 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1));
	}
#line 219 "LibIDN.xs"
		len = MAX_DNSLEN-1;
		q = (uint32_t *) malloc(MAX_DNSLEN * sizeof(q[0]));

		if (q)
		{
			res = punycode_decode(strlen(string), string, &len, q, NULL );
		}
		else
		{
			XSRETURN_UNDEF;
		}
		if (res != PUNYCODE_SUCCESS)
		{
			XSRETURN_UNDEF;
		}
		q[len] = '\0';

		utf8_str = stringprep_ucs4_to_utf8(q, -1, NULL, NULL);
		free(q);

		if (utf8_str)
		{
			res_str = stringprep_convert(utf8_str, charset, "UTF-8");
			free(utf8_str);
		}
		else
		{
			XSRETURN_UNDEF;
		}

		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 378 "LibIDN.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 257 "LibIDN.xs"
		free(res_str);
#line 382 "LibIDN.c"
    }
    XSRETURN(1);
}


XS(XS_Net__LibIDN_idn_prep_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_idn_prep_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::idn_prep_name", "string, charset=default_charset");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	string = (char *)SvPV_nolen(ST(0));
	char *	charset;
#line 266 "LibIDN.xs"
		char *	res_str = NULL;
#line 404 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1));
	}
#line 268 "LibIDN.xs"
		res_str = idn_prep(string, charset, "Nameprep");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 420 "LibIDN.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 277 "LibIDN.xs"
		free(res_str);
#line 424 "LibIDN.c"
    }
    XSRETURN(1);
}


XS(XS_Net__LibIDN_idn_prep_kerberos5); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_idn_prep_kerberos5)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::idn_prep_kerberos5", "string, charset=default_charset");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	string = (char *)SvPV_nolen(ST(0));
	char *	charset;
#line 286 "LibIDN.xs"
		char *	res_str = NULL;
#line 446 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1));
	}
#line 288 "LibIDN.xs"
		res_str = idn_prep(string, charset, "KRBprep");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 462 "LibIDN.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 297 "LibIDN.xs"
		free(res_str);
#line 466 "LibIDN.c"
    }
    XSRETURN(1);
}


XS(XS_Net__LibIDN_idn_prep_node); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_idn_prep_node)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::idn_prep_node", "string, charset=default_charset");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	string = (char *)SvPV_nolen(ST(0));
	char *	charset;
#line 305 "LibIDN.xs"
		char *	res_str = NULL;
#line 488 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1));
	}
#line 307 "LibIDN.xs"
		res_str = idn_prep(string, charset, "Nodeprep");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 504 "LibIDN.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 316 "LibIDN.xs"
		free(res_str);
#line 508 "LibIDN.c"
    }
    XSRETURN(1);
}


XS(XS_Net__LibIDN_idn_prep_resource); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_idn_prep_resource)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::idn_prep_resource", "string, charset=default_charset");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	string = (char *)SvPV_nolen(ST(0));
	char *	charset;
#line 325 "LibIDN.xs"
		char *	res_str = NULL;
#line 530 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1));
	}
#line 327 "LibIDN.xs"
		res_str = idn_prep(string, charset, "Resourceprep");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 546 "LibIDN.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 336 "LibIDN.xs"
		free(res_str);
#line 550 "LibIDN.c"
    }
    XSRETURN(1);
}


XS(XS_Net__LibIDN_idn_prep_plain); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_idn_prep_plain)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::idn_prep_plain", "string, charset=default_charset");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	string = (char *)SvPV_nolen(ST(0));
	char *	charset;
#line 345 "LibIDN.xs"
		char *	res_str = NULL;
#line 572 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1));
	}
#line 347 "LibIDN.xs"
		res_str = idn_prep(string, charset, "plain");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 588 "LibIDN.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 356 "LibIDN.xs"
		free(res_str);
#line 592 "LibIDN.c"
    }
    XSRETURN(1);
}


XS(XS_Net__LibIDN_idn_prep_trace); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_idn_prep_trace)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::idn_prep_trace", "string, charset=default_charset");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	string = (char *)SvPV_nolen(ST(0));
	char *	charset;
#line 365 "LibIDN.xs"
		char *	res_str = NULL;
#line 614 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1));
	}
#line 367 "LibIDN.xs"
		res_str = idn_prep(string, charset, "trace");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 630 "LibIDN.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 376 "LibIDN.xs"
		free(res_str);
#line 634 "LibIDN.c"
    }
    XSRETURN(1);
}


XS(XS_Net__LibIDN_idn_prep_sasl); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_idn_prep_sasl)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::idn_prep_sasl", "string, charset=default_charset");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	string = (char *)SvPV_nolen(ST(0));
	char *	charset;
#line 385 "LibIDN.xs"
		char *	res_str = NULL;
#line 656 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1));
	}
#line 387 "LibIDN.xs"
		res_str = idn_prep(string, charset, "SASLprep");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 672 "LibIDN.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 396 "LibIDN.xs"
		free(res_str);
#line 676 "LibIDN.c"
    }
    XSRETURN(1);
}


XS(XS_Net__LibIDN_idn_prep_iscsi); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_idn_prep_iscsi)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::idn_prep_iscsi", "string, charset=default_charset");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	string = (char *)SvPV_nolen(ST(0));
	char *	charset;
#line 405 "LibIDN.xs"
		char *		res_str = NULL;
#line 698 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1));
	}
#line 407 "LibIDN.xs"
		res_str = idn_prep(string, charset, "ISCSIprep");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 714 "LibIDN.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 416 "LibIDN.xs"
		free(res_str);
#line 718 "LibIDN.c"
    }
    XSRETURN(1);
}

#ifdef HAVE_TLD
#define XSubPPtmpAAAA 1


XS(XS_Net__LibIDN_tld_check); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_tld_check)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::tld_check", "string, errpos, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	string = (char *)SvPV_nolen(ST(0));
	size_t	errpos = (size_t)SvUV(ST(1));
#line 427 "LibIDN.xs"
		STRLEN	c_len;
		char * charset = default_charset;
		char * tld = NULL;
		const Tld_table * tld_table = NULL;
		uint32_t *q;
		size_t len;
		char * utf8_str = NULL;
		char * tmp_str = NULL;
		int res;
#line 751 "LibIDN.c"
	int	RETVAL;
	dXSTARG;
#line 437 "LibIDN.xs"
		if (items>2)
		{
			if (ST(2) != &PL_sv_undef)
				charset = (char*)SvPV(ST(2), c_len);
		}
		if (items>3)
		{
			tld =  (char*)SvPV(ST(3), c_len);
			tld_table = tld_default_table(tld, NULL);
		}
		utf8_str = stringprep_convert(string, "UTF-8", charset);
		if (!utf8_str)
		{
			XSRETURN_UNDEF;
		}
		res = stringprep_profile(utf8_str, &tmp_str, "Nameprep", 0);
		free(utf8_str);
		if (res != STRINGPREP_OK)
		{
			XSRETURN_UNDEF;
		}
		if (tld)
		{
			q = stringprep_utf8_to_ucs4(tmp_str, -1, &len);
			free(tmp_str);
			if (!q)
			{
				XSRETURN_UNDEF;
			}
			res = tld_check_4t(q, len, &errpos, tld_table);
			free(q);
		}
		else
		{
			res = tld_check_8z(tmp_str, &errpos, NULL);
			free(tmp_str);
		}
		if (res == TLD_SUCCESS)
		{
			RETVAL = 1;
		}
		else if (res == TLD_INVALID)
		{
			RETVAL = 0;
		}
		else
		{
			XSRETURN_UNDEF;
		}
#line 804 "LibIDN.c"
	sv_setuv(ST(1), (UV)errpos);
	SvSETMAGIC(ST(1));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__LibIDN_tld_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_tld_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::tld_get", "string");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	string = (char *)SvPV_nolen(ST(0));
#line 495 "LibIDN.xs"
		char *res_str = NULL;
		int res;
#line 829 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;
#line 498 "LibIDN.xs"
		res = tld_get_z(string, &res_str);
		if (res == TLD_SUCCESS)
		{
			RETVAL = res_str;
		}
		else
		{
			XSRETURN_UNDEF;
		}
#line 842 "LibIDN.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 510 "LibIDN.xs"
		free(res_str);
#line 846 "LibIDN.c"
    }
    XSRETURN(1);
}


XS(XS_Net__LibIDN_tld_get_table); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__LibIDN_tld_get_table)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::LibIDN::tld_get_table", "tld");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	tld = (char *)SvPV_nolen(ST(0));
#line 518 "LibIDN.xs"
		const Tld_table * tld_table = NULL;
		HV * rh, * reh;
		AV * ra;
		const Tld_table_element *e;
		size_t pos;
#line 871 "LibIDN.c"
	SV *	RETVAL;
#line 524 "LibIDN.xs"
		tld_table = tld_default_table(tld, NULL);
		if (tld_table)
		{
			rh = (HV *)sv_2mortal((SV *)newHV());
			hv_store(rh, "name", 4, newSVpv(tld_table->name, 0), 0);
			hv_store(rh, "version", 7, newSVpv(tld_table->version, 0), 0);
			hv_store(rh, "nvalid", 6, newSVuv(tld_table->nvalid), 0);
			ra = (AV *)sv_2mortal((SV *)newAV());
			for (pos=0, e = tld_table->valid; pos<tld_table->nvalid; pos++,e++)
			{
				reh = (HV *)sv_2mortal((SV *)newHV());
				hv_store(reh, "start", 5, newSVuv(e->start), 0);
				hv_store(reh, "end", 3, newSVuv(e->end), 0);
				av_push(ra, newRV((SV *)reh));
			}
			hv_store(rh, "valid", 5, newRV((SV*)ra), 0);
			RETVAL = newRV((SV*)rh);
		}
		else
		{
			XSRETURN_UNDEF;
		}
#line 896 "LibIDN.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#endif /* #ifdef HAVE_TLD */
#ifdef __cplusplus
extern "C"
#endif
XS(boot_Net__LibIDN); /* prototype to pass -Wmissing-prototypes */
XS(boot_Net__LibIDN)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("Net::LibIDN::constant", XS_Net__LibIDN_constant, file);
        newXSproto("Net::LibIDN::idn_to_ascii", XS_Net__LibIDN_idn_to_ascii, file, "$;$$");
        newXSproto("Net::LibIDN::idn_to_unicode", XS_Net__LibIDN_idn_to_unicode, file, "$;$$");
        newXSproto("Net::LibIDN::idn_punycode_encode", XS_Net__LibIDN_idn_punycode_encode, file, "$;$");
        newXSproto("Net::LibIDN::idn_punycode_decode", XS_Net__LibIDN_idn_punycode_decode, file, "$;$");
        newXSproto("Net::LibIDN::idn_prep_name", XS_Net__LibIDN_idn_prep_name, file, "$;$");
        newXSproto("Net::LibIDN::idn_prep_kerberos5", XS_Net__LibIDN_idn_prep_kerberos5, file, "$;$");
        newXSproto("Net::LibIDN::idn_prep_node", XS_Net__LibIDN_idn_prep_node, file, "$;$");
        newXSproto("Net::LibIDN::idn_prep_resource", XS_Net__LibIDN_idn_prep_resource, file, "$;$");
        newXSproto("Net::LibIDN::idn_prep_plain", XS_Net__LibIDN_idn_prep_plain, file, "$;$");
        newXSproto("Net::LibIDN::idn_prep_trace", XS_Net__LibIDN_idn_prep_trace, file, "$;$");
        newXSproto("Net::LibIDN::idn_prep_sasl", XS_Net__LibIDN_idn_prep_sasl, file, "$;$");
        newXSproto("Net::LibIDN::idn_prep_iscsi", XS_Net__LibIDN_idn_prep_iscsi, file, "$;$");
#if XSubPPtmpAAAA
        newXSproto("Net::LibIDN::tld_check", XS_Net__LibIDN_tld_check, file, "$$;$$");
        newXSproto("Net::LibIDN::tld_get", XS_Net__LibIDN_tld_get, file, "$");
        newXSproto("Net::LibIDN::tld_get_table", XS_Net__LibIDN_tld_get_table, file, "$");
#endif

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#line 944 "LibIDN.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

